# Halftone2 Class Reference

`#include <halftone2.h>`

Inheritance diagram for Halftone2:

List of all members.

## Public Member Functions

| Halftone2 ()
virtual bool | set_param (const synfig::String &param, const synfig::ValueBase &value)
| Sets the parameter described by param to value.
virtual synfig::ValueBase | get_param (const synfig::String &param) const
| Get the value of the specified parameter.
virtual synfig::Color | get_color (synfig::Context context, const synfig::Point &pos) const
| Gets the color of the Canvas at pos.
virtual bool | accelerated_render (synfig::Context context, synfig::Surface *surface, int quality, const synfig::RendDesc &renddesc, synfig::ProgressCallback *cb) const
| Renders the Canvas to the given Surface in an accelerated manner.
synfig::Layer::Handle | hit_check (synfig::Context context, const synfig::Point &point) const
| Checks to see if a part of the layer is directly under point.
virtual Vocab | get_param_vocab () const
| Gets the parameter vocabulary.
virtual bool | reads_context () const
| Returns true if the layer needs to be able to examine its context.

## Constructor & Destructor Documentation

Halftone2::Halftone2 | ( |  | ) |

References Halftone::angle, Halftone::origin, synfig::Layer_Composite::set_blend_method(), Halftone::size, Halftone::type, TYPE_SYMMETRIC, and zero().

## Member Function Documentation

bool Halftone2::set_param | ( | const synfig::String & | param,
|  | const synfig::ValueBase & | value |
| ) |  |  | `[virtual]`

Sets the parameter described by param to value.

Parameters:

  | param | The name of the parameter to set
  | value | What the parameter is to be set to.

Returns:
  `true` on success, `false` upon rejection or failure. If it returns `false`, then the Layer is assumed to remain unchanged.

See also:
  get_param()

Todo:
  param should be of the type `const String &param`

Reimplemented from synfig::Layer_Composite.

References Halftone::angle, IMPORT, IMPORT_AS, Halftone::origin, Halftone::size, and Halftone::type.

ValueBase Halftone2::get_param | ( | const synfig::String & | param | ) | const`[virtual]`

Get the value of the specified parameter.

Returns:
  The requested parameter value, or (upon failure) a NIL ValueBase.

See also:
  set_param()

Todo:
  param should be of the type `const String &`

Reimplemented from synfig::Layer_Composite.

References Halftone::angle, EXPORT, EXPORT_AS, EXPORT_NAME, EXPORT_VERSION, Halftone::origin, Halftone::size, and Halftone::type.

Color Halftone2::get_color | ( | synfig::Context | context,
|  | const synfig::Point & | pos |
| ) |  |  | const`[virtual]`

Gets the color of the Canvas at pos.

Parameters:

  | context | Context iterator referring to next Layer.
  | pos | Point which indicates where the Color should come from

See also:
  Handle::get_color()

Reimplemented from synfig::Layer.

References synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), and synfig::Context::get_color().

bool Halftone2::accelerated_render | ( | synfig::Context | context,
|  | synfig::Surface * | surface,
|  | int | quality,
|  | const synfig::RendDesc & | renddesc,
|  | synfig::ProgressCallback * | cb |
| ) |  |  | const`[virtual]`

Renders the Canvas to the given Surface in an accelerated manner.

Parameters:

  | context | Context iterator referring to next Layer.
  | surface | Pointer to Surface to render to.
  | quality | The requested quality-level to render at.
  | renddesc | The associated RendDesc.
  | cb | Pointer to callback object. May be NULL if there is no callback.

Returns:
  `true` on success, `false` on failure

See also:
  Handle::accelerated_render()

Reimplemented from synfig::Layer_Composite.

References std::abs(), synfig::Context::accelerated_render(), synfig::ProgressCallback::amount_complete(), synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), synfig::RendDesc::get_ph(), synfig::RendDesc::get_pw(), synfig::RendDesc::get_tl(), synfig::Layer_Composite::is_solid_color(), and Halftone::size.

synfig::Layer::Handle Halftone2::hit_check | ( | synfig::Context | context,
|  | const synfig::Point & | point |
| ) |  |  | const`[virtual]`

Checks to see if a part of the layer is directly under point.

Parameters:

  | context | Context iterator referring to next Layer.
  | point | The point to check

Returns:
  The handle of the layer under point. If there is not a layer under point, then returns an empty handle.

Reimplemented from synfig::Layer.

Layer::Vocab Halftone2::get_param_vocab | ( | void |  | ) | const`[virtual]`

Gets the parameter vocabulary.

Reimplemented from synfig::Layer_Composite.

References _, TYPE_DIAMOND, TYPE_LIGHTONDARK, TYPE_STRIPE, and TYPE_SYMMETRIC.

virtual bool Halftone2::reads_context | ( |  | ) | const`[inline, virtual]`

Returns true if the layer needs to be able to examine its context.

context to render itself, other than for simple blending. For example, the blur layer will return true - it can't do its job if it can't see its context, and the circle layer will return false - rendering a circle doesn't depend on the underlying context until the final blend operation.

Reimplemented from synfig::Layer.

The documentation for this class was generated from the following files:

- halftone2.h
- halftone2.cpp